<template>
  <Row class="manager-user-list">
    <stock-list-page
      :search-columns="searchColumns"
      :table-columns="tableColumns"
      :table-data="users"
      :total-data-amount="totalUsers"
      @search="searchAction">
      <Row>
        <div class="literal-div-btn create-btn" @click="addNewUserAction">NEW User</div>
      </Row>
    </stock-list-page>
  </Row>
</template>

<script>
import StockListPage from '../../../components/StockListPage';
import { columns } from '../../../helpers/list';
import { validators as api } from '../../../configs/request-validator/user';

const actions = {
  async searchAction(filter) {
    const requestData = {
      pageAt: filter.pageAt || 1,
      pageSize: filter.pageSize || 30,
    };
    if (filter.column) {
      const isManager = filter.value.includes('m');
      const isUser = filter.value.includes('u');
      filter.value = (isManager) ? 1 : (isUser) ? 2 : filter.value;
    }
    this.$conditionMutator(requestData, filter);

    try {
      const { data: { users, total} } = await this.$api(api.AccessUsersRequest, requestData);
      this.users = users;
      this.totalUsers = total;
    } catch (error) {
      console.log(error);
      this.$apiErrorHandler(error);
    }
  },
  addNewUserAction() {
    this.$redirectTo('manager-user-id', { id: '-1' });
  },
  viewUserAction(userId) {
    this.$redirectTo('manager-user-id', { id: userId });
  }
};

export default {
  name: 'index',
  components: {
    'stock-list-page': StockListPage,
  },
  data() {
    return {
      searchColumns: [
        {value: 'id', label: 'ID'},
        {value: 'name', label: 'Name'},
        {value: 'type', label: 'Type'},
      ],
      tableColumns: [
        // columns.selection,
        columns.index,
        columns.id,
        {title: 'Name', key: 'name'},
        {title: 'Type', key: 'type'},
        {title: 'Create Date', key: 'createdAt'},
        {title: 'Delete Date', key: 'deletedAt'},
        {
          title: 'Actions',
          width: 150,
          align: 'center',
          fixed: 'right',
          render: (h, param) => {
            const vue = this;
            const userId = param.row['id'];
            return h('div', [
              h('div', {
                  class: 'user-view-btn div-btn inline-block',
                  on: { click: () => { vue.viewUserAction(userId) } }
                },
                [
                  h('Icon', { props: { type: 'md-eye' } })
                ]),
            ]);
          }
        }
      ],
      users: undefined,
      totalUsers: 0,
    };
  },
  methods: {
    ...actions,
  },
  mounted() {
    this.$displayBodyBlock(false);
  },
  async asyncData({ app }) {
    let users = [];
    let totalUsers = 0;

    // request
    const usersRequest = {
      pageAt: 1,
      pageSize: 30,
    };
    app.$conditionMutator(usersRequest, {});

    // invoke api
    try {
      const allResponse = await Promise.all([
        app.$api(api.AccessUsersRequest, usersRequest, undefined, false),
      ]);

      // set vue value
      users = allResponse[0]['data']['users'];
      totalUsers = allResponse[0]['data']['total'];
    } catch (error) {
      app.$apiErrorHandler(error);
    }

    return { users, totalUsers };
  },
}
</script>

<style lang="scss">
  @import "../../../assets/css/mixin";

  .manager-user-list {
    .user-view-btn {
      @include circle-div-btn(32);
    }
  }
</style>
